libsigc++ 2.0: sigc::slot2< T_return, T_arg1, T_arg2 > Class Template Reference

Main Page Groups Namespaces

# sigc::slot2< T_return, T_arg1, T_arg2 > Class Template Reference
[Slots]

Converts an arbitrary functor to a unified type which is opaque. More...

Inheritance diagram for sigc::slot2< T_return, T_arg1, T_arg2 >:

[legend]
List of all members.

## Public Types
typedef T_return | result_type
typedef type_trait< T_arg1 >::take | arg1_type_
typedef type_trait< T_arg2 >::take | arg2_type_
## Public Member Functions
T_return | operator() (arg1_type_ _A_a1, arg2_type_ _A_a2) const
| Invoke the contained functor unless slot is in blocking state.
| slot2 ()
template<class T_functor>
| slot2 (const T_functor& _A_func)
| Constructs a slot from an arbitrary functor.
| slot2 (const slot2& src)
slot2& | operator= (const slot2& src)
| Overrides this slot making a copy from another slot.

## Detailed Description

### template <class T_return, class T_arg1, class T_arg2>
class sigc::slot2< T_return, T_arg1, T_arg2 >

Converts an arbitrary functor to a unified type which is opaque.

sigc::slot itself is a functor or to be more precise a closure. It contains a single, arbitrary functor (or closure) that is executed in operator()().

The template arguments determine the function signature of operator()():

- T_return The return type of operator()().
- T_arg1 Argument type used in the definition of operator()(). The default `nil` means no argument.
- T_arg2 Argument type used in the definition of operator()(). The default `nil` means no argument.

To use simply assign the slot to the desired functor. If the functor is not compatible with the parameter list defined with the template arguments compiler errors are triggered. When called the slot will invoke the functor with minimal copies. block() and unblock() can be used to block the functor's invocation from operator()() temporarily.

You should use the more convenient unnumbered sigc::slot template.

## Member Typedef Documentation

template <class T_return, class T_arg1, class T_arg2>
typedef type_trait<T_arg1>::take sigc::slot2<T_return, T_arg1, T_arg2>::arg1_type_

template <class T_return, class T_arg1, class T_arg2>
typedef type_trait<T_arg2>::take sigc::slot2<T_return, T_arg1, T_arg2>::arg2_type_

template <class T_return, class T_arg1, class T_arg2>
typedef T_return sigc::slot2<T_return, T_arg1, T_arg2>::result_type

## Constructor & Destructor Documentation

template <class T_return, class T_arg1, class T_arg2>
sigc::slot2<T_return, T_arg1, T_arg2>::slot2 | ( |  | ) | `[inline]`

template <class T_return, class T_arg1, class T_arg2>
template <class T_functor>
sigc::slot2<T_return, T_arg1, T_arg2>::slot2 | ( | const T_functor& | _A_func | ) | `[inline]`

  | Constructs a slot from an arbitrary functor. Parameters:
  | _A_func | The desirer functor the new slot should be assigned to.

template <class T_return, class T_arg1, class T_arg2>
sigc::slot2<T_return, T_arg1, T_arg2>::slot2 | ( | const slot2<T_return, T_arg1, T_arg2>& | src | ) | `[inline]`

## Member Function Documentation

template <class T_return, class T_arg1, class T_arg2>
T_return sigc::slot2<T_return, T_arg1, T_arg2>::operator() | ( | arg1_type_ | _A_a1,
|  | arg2_type_ | _A_a2
| ) | const`[inline]`

  | Invoke the contained functor unless slot is in blocking state. Parameters:
  | _A_a1 | Argument to be passed on to the functor.
  | _A_a2 | Argument to be passed on to the functor.
Returns: The return value of the functor invocation.

template <class T_return, class T_arg1, class T_arg2>
slot2& sigc::slot2<T_return, T_arg1, T_arg2>::operator= | ( | const slot2<T_return, T_arg1, T_arg2>& | src | ) | `[inline]`

  | Overrides this slot making a copy from another slot. Parameters:
  | src | The slot from which to make a copy.
Returns: `this`.

The documentation for this class was generated from the following file:

- functors/slot.h